#include <stdio.h>
#include <stdlib.h>
#include "ttftool.h"

int  main(int argc, char** argv) {
    TT_Engine		engine;
    TT_Error		error;
    TT_Face		face;
    TT_Face_Properties  properties;
    TT_OS2		os2;
    int			i, j, face_num, name_num;
    char	        name_string[1024];

    if (argc != 2) {
      fprintf(stderr, "Ȥ: %s fontname\n", argv[0]);
      exit(EXIT_FAILURE);
    }
    if ((error = TT_Init_FreeType(&engine))) {
      fprintf(stderr, "FreeTypeѤǤؤ: %s\n", TT_ErrToString18(error));
      exit(EXIT_FAILURE);
    }
    error = TT_Open_Face(engine, argv[1], &face);
    if (error) {
      fprintf(stderr, "%s Ĥؤ: %s\n", argv[1], TT_ErrToString18(error));
      exit(EXIT_FAILURE);
    }
    error = TT_Get_Face_Properties(face, &properties);
    if (error) {
      fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
      exit(EXIT_FAILURE);
    }
    face_num = properties.num_Faces;
    os2 = *(properties.os2);
    printf("٥̾ϡ%sǤ\n\n", get_vendor(os2));
    TT_Close_Face(face);
    for(i = 0;i < face_num;i++) {
      error = TT_Open_Collection(engine, argv[1], i, &face );
      if (error) {
        fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
        continue;
      }
      name_num = TT_Get_Name_Count(face);
      for(j = 0;j < name_num;j++) {
        name_properties name;

        get_name_properties(face, j, &name);
        printf("face[%d] index[%d] [%s] [%s] [%s] [%s] ", i, j, get_platform(name), 
               get_encoding(name), get_language(name), get_desc(name));
        get_namestring(face, name.platformID, j, name_string);
        printf("[%s]\n", name_string);
      }
      TT_Close_Face(face);
    }
    TT_Done_FreeType(engine);
    return 0;
}
