#include <stdio.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "ttftool.h"

struct info_ {
  int  face;
  char file_name[256];
  char ascii_name[64];
  char jp_name[64];
  char post_name[64];
  char vendor_name[64];
  char weight[64];
  int  offset;
  int  ri;
  char path[512];
};
typedef struct info_ info;

void ttfnum(char *path, int *n, int *f, int *t) {
  DIR* directory;
  struct dirent *dirent_ptr;
  char name[MAXNAMLEN];
  TT_Engine engine;
  TT_Error  error;
  TT_Face   face;
  TT_Face_Properties  properties;
  int face_num;
  type1_properties type1;

  if((error = TT_Init_FreeType(&engine))) {
    fprintf(stderr, "FreeTypeѤǤؤ: %s\n", TT_ErrToString18(error));
    exit(EXIT_FAILURE);
  }
  directory = opendir(path);
  if(!directory) exit(-1);
  *t = *n = *f = 0;
  while((dirent_ptr = readdir(directory)) != NULL) {
    strcpy(name, path);
    strcat(name, "/");
    strcat(name, dirent_ptr->d_name);
    if((error = TT_Open_Face(engine, name, &face))) {
       if(get_type1_string(name, &type1) == FALSE) continue;
    } else {
      error = TT_Get_Face_Properties(face, &properties);
      if (error) {
        fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
        exit(EXIT_FAILURE);
      }
      face_num = properties.num_Faces;
      if(face_num > get_max_face()) face_num = get_max_face();
      *f += face_num;
      TT_Close_Face(face);
      (*t)++;
    }
    (*n)++;
  }
  closedir(directory);
  TT_Done_FreeType(engine);
}

void ttfout(char *buffer, info infos, FILE *fo) {
  int n, i;
  char name[MAXNAMLEN], str[1024], com[1024], *p;

  strcpy(name, infos.file_name);
  if((p = strrchr(name, '.')) != NULL) *p = 0;
  p = com;
  n = strlen(buffer);
  for(i = 0;i < n;i++) {
    if(buffer[i] == '%') {
      switch(buffer[i + 1]) {
      case 't':
        sprintf(str, "%s", name);
        i++; break;
      case 'f':
        sprintf(str, "%s", infos.file_name);
        i++; break;
      case 'n':
        sprintf(str, "%s", infos.ascii_name);
        i++; break;
      case 'j':
        sprintf(str, "%s", infos.jp_name);
        i++; break;
      case 'p':
        sprintf(str, "%s", infos.post_name);
        i++; break;
      case 'v':
        sprintf(str, "%s", infos.vendor_name);
        i++; break;
      case 'i':
        sprintf(str, "%d", infos.face);
        i++; break;
      case 'o':
        sprintf(str, "%d", infos.offset);
        i++; break;
      case 'd':
        sprintf(str, "%s", infos.path);
        i++; break;
      case 's':
        sprintf(str, "%c", infos.face == 0 ? 'c' : 'p');
        i++; break;
      case 'w':
        sprintf(str, "%s", infos.weight);
        i++; break;
      case 'r':
        sprintf(str, "%c", infos.ri);
        i++; break;
      case '%':
        sprintf(str, "%%");
        i++; break;
      default:
        sprintf(str, "%c", buffer[i]);
      }
    } else {
      sprintf(str, "%c", buffer[i]);
    }
    if(fo != NULL) {
      fputs(str, fo);
    } else {
      strcpy(p, str);
      p += strlen(p);
    }
  }
  if(fo == NULL) system(com);
}

void type1_file(char *path, FILE *fp, FILE *fo, int *off, int *inc) {
  DIR* directory;
  struct dirent *dirent_ptr;
  char *cp, name[1024], buffer[65536];
  int i, j, a;
  info infos;
  type1_properties font;

  fgets(name, 1024, fp);
  j = 0;
  while(strncmp(name, "%% end %%", 9) != 0 && !feof(fp)) {
    a = strlen(name);
    for(i = 0;i < a;i++) buffer[j++] = name[i];
    fgets(name, 1024, fp);
  }
  buffer[j] = 0;
  strcpy(infos.path, path);
  directory = opendir(path);
  if(!directory) exit(-1);
  while((dirent_ptr = readdir(directory)) != NULL) {
    strcpy(name, path);
    strcat(name, "/");
    strcat(name, dirent_ptr->d_name);
    strcpy(infos.file_name, dirent_ptr->d_name);
    if(get_type1_string(name, &font)) {
      strcpy(infos.weight, font.weight);
      strcpy(infos.ascii_name, font.fontname);
      strcpy(infos.jp_name, font.fontname);
      strcpy(infos.post_name, font.postname);
      strcpy(infos.vendor_name, font.vendor);
      infos.ri = font.italic;
      infos.face = (font.pitch == 'p') ? 1 : 0;
      infos.offset = *off;
      ttfout(buffer, infos, fo);
      *off += *inc;
    }
  }
  closedir(directory);
}

FILE *preout(FILE *fp, char *atmpath, int num, int fnum, int ttnum,
             int *off, int *inc, info min, info goth, char *setpath) {
  char buffer[1024], str[3][256], name[256], msg[256];
  char *p, sa[64], sb[64], se[64];
  int i, a, b, e;
  FILE *fo, *f;
  info current;

  current = min;
  fgets(buffer, 1024, fp);
  buffer[strlen(buffer) - 1] = 0;
  sscanf(buffer, "%s %s %s %s", str[0], str[1], name, str[2]);
  if(strcmp(str[0], "%%") != 0) return NULL;
  if(strcmp(str[1], "ttftool-define") != 0) return NULL;
  if(strcmp(str[2], "%%") != 0) return NULL;
  unlink(name);
  if((fo = fopen(name, "w")) == NULL) {
    set_err_message("ե뤬񤭹ޤ");
    return NULL;
  }
  fgets(buffer, 1024, fp);
  buffer[strlen(buffer) - 1] = 0;
  while(strcmp(buffer, "%% for %%") != 0 && !feof(fp)) {
    if(strcmp(buffer, "%% for type1 %%") == 0) {
      type1_file(atmpath, fp, fo, off, inc);
    } else if(strstr(buffer, "%% expr ") != NULL) {
      p = buffer + 8;
      sscanf(p, "%s %s %s", sa, se, sb);
      if(sa[0] == '%' && sa[1] == 'c') a = ttnum;
      if(sa[0] == '%' && sa[1] == 'a') a = fnum - ttnum;
      else sscanf(sa, "%d", &a);
      if(sb[0] == '%' && sb[1] == 'c') b = ttnum;
      if(sb[0] == '%' && sb[1] == 'a') b = fnum - ttnum;
      else sscanf(sb, "%d", &b);
      e = 0;
      switch(se[0]) {
      case '+':
        e = a + b; break;
      case '-':
        e = a - b; break;
      case '*':
        e = a * b; break;
      case '/':
        e = a / b; break;
      }
      fprintf(fo, "%d", e);
    } else if(strstr(buffer, "%% setvalue ") != NULL) {
      p = buffer + 12;
      sscanf(p, "%d %d", off, inc);
    } else if(strstr(buffer, "%% mincho ") != NULL) {
      current = min;
    } else if(strstr(buffer, "%% gothic ") != NULL) {
      current = goth;
    } else if(strstr(buffer, "%% loadpath ") != NULL) {
      p = buffer + 12;
      sscanf(p, "%s", setpath);
      if((f = fopen(setpath, "r")) == NULL) {
        setpath[0] = '\0';
      } else {
      	fclose(f);
      	strcpy(atmpath, setpath);
/*      	strcpy(min.path, setpath);
      	strcpy(goth.path, setpath);
      	strcpy(current.path, setpath);*/
      }
    } else {
      ttfout(buffer, current, fo);
      fprintf(fo, "\n");
    }
    fgets(buffer, 1024, fp);
    buffer[strlen(buffer) - 1] = 0;
  }
  return fo;
}

void ttf_file(char *ttpath, char *typath, FILE *fp, info min, info goth) {
  DIR* directory;
  struct dirent *dirent_ptr;
  char *cp, name[1024], buffer[65536], setpath[128], path[128], atmpath[128];
  int i, j, a, b, c, name_num, face_num, num, fnum, ttnum, w, v, jp, p, alt, off, inc;
  TT_Engine engine;
  TT_Error  error;
  TT_Face   face;
  TT_Face_Properties  properties;
  TT_OS2	      os2;
  name_properties prop;
  FILE	*fo;
  info infos;

  infos.ri = 'r';
  setpath[0] = '\0';
  strcpy(path, ttpath);
  strcpy(atmpath, typath);
  strcpy(infos.path, path);
  ttfnum(path, &num, &fnum, &ttnum);
  ttfnum(atmpath, &a, &b, &c);
  fnum += a;
  off = 0, inc = 1;
  if((fo = preout(fp, atmpath, num, fnum, ttnum, &off, &inc, min, goth, setpath)) == NULL) return;
  if(setpath[0] != '\0') strcpy(path, setpath);
  if((error = TT_Init_FreeType(&engine))) {
    fprintf(stderr, "FreeTypeѤǤؤ: %s\n", TT_ErrToString18(error));
    exit(EXIT_FAILURE);
  }
  while(!feof(fp)) {
    fgets(name, 1024, fp);
    j = 0;
    while(strncmp(name, "%% end %%", 9) != 0 && !feof(fp)) {
      a = strlen(name);
      for(i = 0;i < a;i++) buffer[j++] = name[i];
      fgets(name, 1024, fp);
    }
    buffer[j] = 0;
    directory = opendir(path);
    if(!directory) exit(-1);
    while((dirent_ptr = readdir(directory)) != NULL) {
      strcpy(name, path);
      strcat(name, "/");
      strcat(name, dirent_ptr->d_name);
      strcpy(infos.file_name, dirent_ptr->d_name);
      if((error = TT_Open_Face(engine, name, &face))) continue;
      error = TT_Get_Face_Properties(face, &properties);
      if (error) {
        fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
        exit(EXIT_FAILURE);
      }
      face_num = properties.num_Faces;
      if(face_num > get_max_face()) face_num = get_max_face();
      os2 = *(properties.os2);
      strcpy(infos.vendor_name, get_vendor(os2));
      TT_Close_Face(face);
      for(i = 0;i < face_num;i++) {
        infos.face = i;
        error = TT_Open_Collection(engine, name, i, &face );
        if (error) {
          fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
          continue;
        }
        name_num = TT_Get_Name_Count(face);
        w = alt = jp = p = -1;
        for(j = 0;j < name_num;j++) {
          get_name_properties(face, j, &prop);
          if(prop.platformID == 3 && prop.nameID == 4) {
            if(jp == -1) jp = j;
            if(prop.languageID == 0x0411) jp = j;
          }
          if(prop.platformID == 3 && prop.nameID == 6) {
            if(p == -1) p = j;
            if(prop.languageID == 0x409) p = j;
          }
          if(prop.platformID == 3 && prop.nameID == 3) {
            if(alt == -1) alt = j;
            if(prop.languageID == 0x409) alt = j;
          }
          if(prop.platformID == 3 && prop.nameID == 2) {
            if(w == -1) w = j;
	    if(prop.languageID == 0x409) w = j;
	  }
        }
        get_namestring(face, prop.platformID, w, infos.weight);
        get_namestring(face, prop.platformID, jp, infos.jp_name);
        get_namestring(face, prop.platformID, p, infos.post_name);
        for(a = 0;infos.post_name[a] != 0;a++) {
          if(infos.post_name[a] & 0x80) {
            get_namestring(face, prop.platformID, alt, infos.post_name);
            for(a = 0;infos.post_name[a] != 0;a++)
              infos.post_name[a] = (isalnum(infos.post_name[a])) ? infos.post_name[a] : '-';
            break;
          }
        }
        cp = strstr(infos.post_name, "-RKSJ");
        if(cp != NULL) cp[0] = 0;
        cp = strstr(infos.post_name, "-SJIS");
        if(cp != NULL) cp[0] = 0;
        cp = strstr(infos.post_name, "-EUC");
        if(cp != NULL) cp[0] = 0;
        for(a = 0;infos.post_name[a] != 0;a++) {
          infos.ascii_name[a] = (isalnum(infos.post_name[a])) ? infos.post_name[a] : ' ';
          infos.post_name[a] = (infos.post_name[a] !=  ' ') ? infos.post_name[a] : '-';
        }
        infos.ascii_name[a] = 0;
        for(a = 0, b = 0;infos.jp_name[a] != 0;a++) {
          if(infos.jp_name[a] != ' ' || infos.jp_name[a - 1] & 0x80)
            infos.jp_name[b++] = infos.jp_name[a];
        }
        infos.jp_name[b] = 0;
        a = strlen(infos.post_name) - 1; 
        if(infos.post_name[a] == '-') infos.post_name[a] = 0;
        TT_Close_Face(face);
        infos.offset = off;
        ttfout(buffer, infos, fo);
        off += inc;
      }
    }
    closedir(directory);
    fgets(name, 65536, fp);
    while(strncmp(name, "%% for %%", 9) != 0 && !feof(fp)) {
      fputs(name, fo);
      fgets(name, 1024, fp);
    }
  }
  fclose(fo);
  TT_Done_FreeType(engine);
}

info get_defaults(char *path, char *fname) {
  info data;
  char *cp, name[1024], buffer[65536];
  int i, j, a, name_num, face_num, num, fnum, v, jp, p, alt, off, inc, w;
  TT_Engine engine;
  TT_Error  error;
  TT_Face   face;
  TT_Face_Properties  properties;
  TT_OS2	      os2;
  name_properties prop;
  type1_properties font;

  data.ri = 'r';
  data.face = 0;
  data.offset = 0;
  strcpy(data.file_name, fname);
  sprintf(data.path, "%s/%s", path, fname);
  if((error = TT_Init_FreeType(&engine))) {
    fprintf(stderr, "FreeTypeѤǤؤ: %s\n", TT_ErrToString18(error));
    exit(EXIT_FAILURE);
  }
  error = TT_Open_Face(engine, data.path, &face);
  if(error) {
    if(get_type1_string(data.path, &font)) {
      strcpy(data.weight, font.weight);
      strcpy(data.ascii_name, font.fontname);
      strcpy(data.jp_name, font.fontname);
      strcpy(data.post_name, font.postname);
      strcpy(data.vendor_name, "type1");
      strcpy(data.path, path);
      return data;
    } else {
      fprintf(stderr, "FreeTypeѤǤؤ: %s\n", TT_ErrToString18(error));
      exit(EXIT_FAILURE);
    }
  }
  error = TT_Get_Face_Properties(face, &properties);
  if (error) {
    fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
    exit(EXIT_FAILURE);
  }
  face_num = properties.num_Faces;
  if(face_num > get_max_face()) face_num = get_max_face();
  os2 = *(properties.os2);
  strcpy(data.vendor_name, get_vendor(os2));
  TT_Close_Face(face);
  error = TT_Open_Collection(engine, data.path, 0, &face );
  name_num = TT_Get_Name_Count(face);
  w = alt = jp = p = -1;
  for(j = 0;j < name_num;j++) {
    get_name_properties(face, j, &prop);
    if(prop.platformID == 3 && prop.nameID == 4) {
      if(jp == -1) jp = j;
      if(prop.languageID == 0x0411) jp = j;
    }
    if(prop.platformID == 3 && prop.nameID == 6) {
      if(p == -1) p = j;
      if(prop.languageID == 0x409) p = j;
    }
    if(prop.platformID == 3 && prop.nameID == 3) {
      if(alt == -1) alt = j;
      if(prop.languageID == 0x409) alt = j;
    }
    if(prop.platformID == 3 && prop.nameID == 2) {
      if(w == -1) w = j;
      if(prop.languageID == 0x409) w = j;
    }
  }
  get_namestring(face, prop.platformID, w, data.weight);
  get_namestring(face, prop.platformID, jp, data.jp_name);
  get_namestring(face, prop.platformID, p, data.post_name);
  for(a = 0;data.post_name[a] != 0;a++) {
    if(data.post_name[a] & 0x80) {
      get_namestring(face, prop.platformID, alt, data.post_name);
      for(a = 0;data.post_name[a] != 0;a++)
        data.post_name[a] = (isalnum(data.post_name[a])) ? data.post_name[a] : '-';
      break;
    }
  }
  cp = strstr(data.post_name, "-RKSJ");
  if(cp != NULL) cp[0] = 0;
  cp = strstr(data.post_name, "-SJIS");
  if(cp != NULL) cp[0] = 0;
  cp = strstr(data.post_name, "-EUC");
  if(cp != NULL) cp[0] = 0;
  for(a = 0;data.post_name[a] != 0;a++) {
    data.ascii_name[a] = (isalnum(data.post_name[a])) ? data.post_name[a] : ' ';
    data.post_name[a] = (data.post_name[a] != ' ') ? data.post_name[a] : '-';
  }
  data.ascii_name[a] = 0;
  a = strlen(data.post_name) - 1; 
  if(data.post_name[a] == '-') data.post_name[a] = 0;
  TT_Close_Face(face);
  TT_Done_FreeType(engine);
  strcpy(data.path, path);
  return data;
}

void ttf_files(char *path, char *atmpath, char *min_file, char *goth_file) {
  DIR* directory;
  struct dirent *dirent_ptr;
  char name[260];
  FILE *fp;
  info min, goth;

  set_err_message("");
  directory = opendir("/etc");
  if(!directory) exit(-1);
  min = get_defaults(path, min_file);
  goth = get_defaults(path, goth_file);
  while((dirent_ptr = readdir(directory)) != NULL) {
    sprintf(name, "/etc/%s", dirent_ptr->d_name);
    if(strstr(dirent_ptr->d_name, ".bak") == NULL &&
       strstr(dirent_ptr->d_name, "~") == NULL &&
       strstr(dirent_ptr->d_name, "startup.ttfdef") == NULL &&
       strstr(dirent_ptr->d_name, "install.ttfdef") == NULL &&
       strstr(dirent_ptr->d_name, ".ttfdef") != NULL &&
       dirent_ptr->d_name[strlen(dirent_ptr->d_name) - 1] != '~') {
      if((fp = fopen(name, "r")) != NULL) {
      	ttf_file(path, atmpath, fp, min, goth);
        fclose(fp);
     }
    }
  }
  closedir(directory);
}

int ttget(TT_Engine engine, char* path, GtkWidget *clist, int flag) {
  TT_Error	error;
  TT_Face	face;
  TT_Face_Properties  properties;
  TT_OS2	os2;
  int		i, j, face_num, name_num, nn;
  char	        name_string[1024];
  gchar		*lists[2];
  name_properties name;

  if((error = TT_Open_Face(engine, path, &face))) return 0;
  error = TT_Get_Face_Properties(face, &properties);
  if (error) {
    fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
    exit(EXIT_FAILURE);
  }
  face_num = properties.num_Faces;
  if(face_num > get_max_face()) face_num = get_max_face();
  TT_Close_Face(face);
  for(i = 0;i < ((flag == 0) ? face_num : 1);i++) {
    error = TT_Open_Collection(engine, path, i, &face );
    if (error) {
      fprintf(stderr, "FreeTypeΥ顼å: %s\n", TT_ErrToString18(error));
      continue;
    }
    name_num = TT_Get_Name_Count(face);
    nn = -1;
    for(j = 0;j < name_num;j++) {
      get_name_properties(face, j, &name);
      if(name.platformID == 3 && name.nameID == 4) {
      	if(nn == -1) nn = j;
      	if(name.languageID == 0x0411) nn = j;
      }
    }
    get_namestring(face, name.platformID, nn, name_string);
    lists[0] = name_string;
    gtk_clist_append(GTK_CLIST(clist), lists);
    TT_Close_Face(face);
  }
  return (flag == 0) ? face_num : 1;
}

char** ttfdir(char *path, GtkWidget *clist, int flag, char *atmpath) {
  DIR* directory;
  struct dirent *dirent_ptr;
  char name[MAXNAMLEN];
  char **list, *ptr;
  int i, n, max, l, num, save, ttnum;
  TT_Engine engine;
  TT_Error  error;
  gchar	    *lists[2];
  type1_properties type1;

  save = 0;
  if(flag == 0) ttfnum(atmpath, &save, &max, &ttnum);
  ttfnum(path, &num, &max, &ttnum);
  if(flag == 1) max = num;
  max++;
  max += save;
  if((error = TT_Init_FreeType(&engine))) {
    fprintf(stderr, "FreeTypeѤǤؤ: %s\n", TT_ErrToString18(error));
    exit(EXIT_FAILURE);
  }
  list = malloc(sizeof(char*) * max);
  ptr = malloc(MAXNAMLEN * max);
  for(i = 0;i < max;i++) list[i] = &(ptr[i * MAXNAMLEN]);
  directory = opendir(path);
  gtk_clist_clear(GTK_CLIST(clist));
  i = 0;
  while((dirent_ptr = readdir(directory)) != NULL) {
    strcpy(name, path);
    strcat(name, "/");
    strcat(name, dirent_ptr->d_name);
    for(n = ttget(engine, name, clist, flag) + i;i < n;i++){
      strcpy(list[i], dirent_ptr->d_name);
      l = strlen(list[i]);
      list[i][l + 1] = 0;
      list[i][l + 2] = 't';
    }
    if(get_type1_string(name, &type1)) {
      strcpy(list[i], dirent_ptr->d_name);
      l = strlen(list[i]);
      list[i][l + 1] = 0;
      list[i][l + 2] = 'a';
      lists[0] = type1.fontname;
      gtk_clist_append(GTK_CLIST(clist), lists);
      i++;
    }
  }
  if(flag == 0) {
    directory = opendir(atmpath);
    while((dirent_ptr = readdir(directory)) != NULL) {
      strcpy(name, atmpath);
      strcat(name, "/");
      strcat(name, dirent_ptr->d_name);
      if(get_type1_string(name, &type1)) {
        strcpy(list[i], dirent_ptr->d_name);
        l = strlen(list[i]);
        list[i][l + 1] = 0;
        list[i][l + 2] = 'a';
        lists[0] = type1.fontname;
        gtk_clist_append(GTK_CLIST(clist), lists);
        i++;
      }
    }
  }
  list[i] = NULL;
  closedir(directory);
  TT_Done_FreeType(engine);
  return list;
}

void ttfinstall(char *path, char *file, char *config) {
  char buffer[1024];
  FILE *fp;
  info data;

  if((fp = fopen(config, "r")) == NULL) return;
  data = get_defaults(path, file);
  fgets(buffer, 1024, fp);
  while(!feof(fp)) {
    buffer[strlen(buffer) - 1] = 0;
    ttfout(buffer, data, NULL);
    fgets(buffer, 1024, fp);
  }
  fclose(fp);
}
